#!/bin/bash

#-------------------- hw section -------------------------------

#### Ask for a number of chunks (select=) each with cpus "ncpus" 
#PBS -l select=2:ncpus=16:mpiprocs=16:mem=12gb
###PBS -l select=2:ncpus=16:mpiprocs=1:mem=12gb

#-------------------- queue system -------------------------------

#### Queue of submission
#PBS -q debug

#### Maximum length of the job (hh:mm:ss)
#PBS -l walltime=00:03:00  

# --------------- accounting/budget  -----------------------------

#### account number (type saldo -b)
#PBS -A 

# ---------------- other info ------------------------------------

#### File for standard output and error
#PBS -o job.out
#PBS -e job.err

#### Job name
#PBS -N hello_my_friend

#### send email to the following address
##PBS -M <your_address@dot.com>

#### send emai after abort or end
#PBS -m ae

# -----------end of PBS keywords section -------------------------


cd $PBS_O_WORKDIR

module load intel/cs-xe-2013--binary
module load intelmpi/4.1.1--binary

mpirun -n 32 ./test.x 
#mpirun -n 2 ./test.x 


